#!/usr/local/bin/perl


#                                      \\\|/// 
#                                    \\  ~ ~  // 
#                                     (  @ @  )  
#**********************************-oOOo-(_)-oOOo-************************************
#
#         Natural Language Processing 
#
#         CS8761   -   Dr. Ted Pedersen
#
#         FINAL PROJECT
#
#         An approach to sentiment classification using machine readable dictionaries
#         and World Wide Web 
#
#         
#         Melgar FBC - Prashant Jain , Anand Takale , Nan Zhang ,Sumalatha Kothadi 
#
#
#***************************************-OoooO-***************************************
#                              .oooO     (   ) 
#                              (   )      ) / 
#                               \ (      (_/ 
#                                \_) 






use LDOCE::ldoce;                                                       # use the LDOCE module
use BigMac::bigmac;                                                     # use the BigMac modeule 
use WebReader::WebSearch;                                               # use the WebReader module

print "\n\nInitalizing BigMac Dictionary";

bigmac::initialize();                                                   # initialize bigmac dictionary takes couple of minutes

%good_words = ();
%bad_words = ();
%adjhash = ();
$good_count = 0;
$bad_count = 0;
$true_answer = "";


open(TRACE,">>trace1.txt");

$word[0]="good";

%good_words = bigmac::shared_definition(@word);                         # extracting good words from BigMac

foreach $goodword(keys %good_words)
{
    $good_count++;
}

print TRACE "Good hash created....\n\n\n";

$word1[0] = "bad";
%bad_words = bigmac::shared_definition(@word1);                         # extracting bad words from BigMac

print TRACE "Bad hash done...\n\n\n";

foreach $badwords(keys %bad_words)
{
    $bad_count++;
}

$pos = "adjective";
%hash1 = bigmac::particular_pos($pos);                                  # extracting all adjectives from BigMac


$adj_count = 0;

foreach $x(keys %hash1)
{
    $adj_count++;
    $x = uc($x);
   $hash{$x}++;
}

print TRACE "BigMac adjective hash done...\n\n\n";


%good_words1 = ldoce::similar_def(@word);                               # extracting good words from LDOCE


foreach $goodword(keys %good_words1)
{
    $goodword = uc($goodword);
    $good_words{$goodword}++;
}

print TRACE "Good hash created....\n\n\n";

%bad_words1 = ldoce::similar_def(@word1);                               # extracting bad words from LDOCE

print TRACE "Bad hash done...\n\n\n";

foreach $badwords(keys %bad_words1)
{
    $badwords=uc($badwords);
    $bad_words{$badwords}++;;
}

foreach $badwords(keys %bad_words)
{
    $bad_count++;
}


foreach $goodword(keys %good_words)
{
    $good_count++;
}

$pos = "adj";
%hash2 = ldoce::same_pos($pos);                                         # extracting adjectives from LDOCE


$adj_cnt = 0;


foreach $x(keys %hash2)
{    
    $x = uc($x);
    $hash{$x}++;
}


foreach $y(keys %hash)
{
    $adj_cnt++;
}

print  TRACE "LDOCE  adjective hash done...\n\n\n";




open(CACHE,"cache");                                                    # getting the words and hits from the existing cache
while($line = <CACHE>)
{
    chomp($line);
    @split_arr = split/ /,$line;
    $exist_hash{$split_arr[0]}{"pos_sc"} = $split_arr[1];
    $exist_hash{$split_arr[0]}{"neg_sc"} = $split_arr[2];
    $exist_hash{$split_arr[0]}{"pos_b"} = $split_arr[3];
    $exist_hash{$split_arr[0]}{"neg_b"} = $split_arr[4];
    $exist_hash{$split_arr[0]}{"only_word"} = $split_arr[5];
    $exist_hash{$split_arr[0]}{"not_good"} = $split_arr[6];
    $exist_hash{$split_arr[0]}{"not_bad"} = $split_arr[7];
}
close(CACHE);
                            
open(POS,"choice.txt") or die "cant find\n";

$pos = <POS>;
chomp($pos);

close(POS);

$correct_classified = 0;
$unclassified = 0;
$total_files = 0;
$precision = 0;
$recall = 0;
$f_measure = 0;


$path = $ARGV[0];
opendir(DIR,"$path");
@allfiles = readdir DIR;

for($i = 0;$i<=$#allfiles;$i++)                                             # loop to scan through all the files of the defines directory structure
{
    if($allfiles[$i] ne "." and $allfiles[$i] ne "..")
    {
	
	$newpath = $path . "/" . $allfiles[$i];
	opendir(DIR1,"$newpath");
	@allsubfiles = readdir DIR1;

	for($q = 0;$q <= $#allsubfiles;$q++)                                # scan through subdirectories ...pos and neg
	{
	    if($allsubfiles[$q] ne "." and $allsubfiles[$q] ne "..")
	    {
		%adjhash = ();
		%eachword = ();
		%adjnew = ();
		$filepath = $newpath . "/" . $allsubfiles[$q];
		open(FILE,$filepath);                                       
		$complete = "";
		while($p = <FILE>)                                          # scan through a single file
		{
		    $complete .= $p;
		}	
		
		%eachword = split/ /,$complete;
		foreach $word(keys %eachword)                               # extracting all adjectives from a single file
		{
		    $word = uc($word);
		    foreach $adjword(keys %hash)
		    {		   
			if($adjword eq $word)
			{
			    $adjhash{$word}++;
			}
		    }
		}
		$final_score = 0;
		$ctr = 0;
	
		foreach $adj(keys %adjhash)
		{
		    web($adj);                                               # function that will assign score to each adjective on the basis of WebSearch
		    mrd($adj);                                               # function that will assign score to each adjective on the bais of MRD's 
		
		}
	
		if($allfiles[$i] eq "pos")                                   # finding the expected answer ....... from the directory name
	        {
		    $true_answer = "positive";
		}
		if($allfiles[$i] eq "neg")
		{
		    $true_answer = "negative";
		}
		
		foreach $adj(keys %adjnew)                                   # calculate score for review depending on individual scores of adjectives
		{
		    print TRACE "INDIVIDUAL SCORE FOR $adj = $adjnew{$adj}\n\n";
		    $final_score += $adjnew{$adj};
		}
		if($final_score > 0)                                         # assigning the classification to the review
		{
	      	    print "$filepath --> positive   expected answer:  $true_answer\n";
		    $num_pos++;
		    if($true_answer eq "positive")
		    {
			$correct_classified++;
		    }
		    
		}
		if($final_score < 0)
		{
		    print "$filepath --> negative   expected answer:  $true_answer\n";
		    $num_neg++;
		    if($true_answer eq "negative")
		    {
			$correct_classified++;
		    }
		}
		if($final_score == 0)
		{
		    print "$filepath --> cant decide expected answer: $true_answer\n";
		    $unclassified++;
		}


		$total_files++;

		print TRACE "\n\n$total_files    :    $correct_classified    :    $unclassified";
		
	   	
		if(($total_files - $unclassified) != 0)                                       # finding precision , recall and the f-measure
		{
		    $precision = $correct_classified/($total_files-$unclassified);
		}
		if($total_files)
		{
		    $recall = $correct_classified / $total_files;
		}
		if(($precision+$recall)!=0)
		{
		    $f_measure = (2*$precision*$recall)/($precision+$recall);
		}
		print TRACE "\n\n$precision   :   $recall    :   $f_measure"; 		
	    }	 
	}

    }
}


open (RESULT,">>results.txt");                                         # printing the output to the results file

print RESULT "\n\nData Set : $argv[0]";
print RESULT "\nPrecision : $precision";
print RESULT "\nRecall : $recall";
print RESULT "\nF-measure : $f_measure";

print "\n\nData Set : $argv[0]";
print "\nPrecision : $precision";
print "\nRecall : $recall";
print "\nF-measure : $f_measure";

sub web                                                               # function to assign score to an adjective on the basis of info. obtained from web
{
    $adj = $_[0];
    $adj = lc($adj);
    $pos_score = 0;
    $neg_score = 0;
    $total_score = 0;
    $denom_pos = 0;
    $denom_neg = 0;
    $t_score_pos = 0;
    $t_score_neg = 0;
    $n21 = 0;
    $n2p = 0;
    $sample_size_pos = 0;
    $sample_size_neg = 0;
    $n21b = 0;
    $n2pb = 0;
    $expected_value_pos = 0;
    $expected_value_neg = 0;
    
    if(exists($exist_hash{$adj}{"pos_sc"}))                                # check whether word already exists in the cache
    {
	
	$pos_score = $exist_hash{$adj}{"pos_sc"};
	$neg_score = $exist_hash{$adj}{"neg_sc"};
	$pos_base = $exist_hash{$adj}{"pos_b"};
	$neg_base = $exist_hash{$adj}{"neg_b"};
	$only_word_score = $exist_hash{$adj}{"only_word"};
	$not_good = $exist_hash{$adj}{"not_good"};
	$not_bad = $exist_hash{$adj}{"not_bad"};
    }
    else                                                                        # if the word is not present in the cache go to the web and get number of hits
    {                                                                           # add the word to the cache and update the cache
	@arr = WebSearch::qhits($adj);
    
	$pos_score = $arr[0];
	$neg_score = $arr[1];
	$pos_base = $arr[2];
	$neg_base = $arr[3];
	$only_word_score = $arr[4];
	$not_good = $arr[5];
	$not_bad = $arr[6];
    }
    $n21 = $pos_base - $pos_score;                                              # constructing the 2*2 contingency matrix
    $n12 = $only_word_score - $pos_score;
    $n2p = $n21 + $not_good;
    $sample_size_pos = $only_word_score + $n2p;
    
    $n21b = $neg_base - $neg_score;
    $n12b = $only_word_score - $neg_score;
    $n2pb = $n21b + $not_bad;
    $sample_size_neg = $only_word_score + $n2pb;

    

    $odds_ratio_pos = (($pos_score + 1) * ($not_good + 1))/(($n21 + 1) * ($n12 + 1));   # calculating the score by odds ratio
    
    $odds_ratio_neg = (($neg_score + 1) * ($not_bad + 1))/(($n21b + 1) * ($n12b + 1));

    if($sample_size_pos > 0)
    {
	$expected_value_pos = ($only_word_score * $pos_base)/$sample_size_pos;
    }
    if($sample_size_neg > 0)
    {
	$expected_value_neg = ($only_word_score * $neg_base)/$sample_size_neg;
    }

    $denom_pos = sqrt($pos_score);
    $denom_neg = sqrt($neg_score);
    
    if($denom_pos > 0)
    {
	$t_score_pos = ($pos_score - $expected_value_pos)/$denom_pos;                      # calculating the t-score value
    }
    if($denom_neg > 0)
    {
	$t_score_neg = ($neg_score - $expected_value_neg)/$denom_neg;
    }


    $dice1 = (2 * ($pos_score))/($pos_base+1 + $only_word_score+1);                       # calculating dice coefficient
    $dice2 = (2 * ($neg_score))/($neg_base+1 + $only_word_score+1);
     
    print TRACE "\n\n$adj : $dice1 : $dice2 : $t_score_pos : $t_score_neg : $odds_ratio_pos : $odds_ratio_neg";
 

    if($dice1 > $dice2)                                                                   # calculating combined score of an adjective depending upon scores
    {                                                                                     # given by all three measures of association
	$adjnew{$adj} += 1;
    }
    if($dice1 < $dice2)
    {
	$adjnew{$adj} -= 1;
    }
    if($dice1 == $dice2)
    {
	$adjnew{$adj} += 0;
    }
    if($t_score_pos > $t_score_neg)
    {
	$adjnew{$adj} += 1;
    }
    if($t_score_pos < $t_score_neg)
    {
	$adjnew{$adj} -= 1;
    }
    if(t_score_pos == $t_score_neg)
    {
	$adjnew{$adj} += 0;
    }
    
    if($odds_ratio_pos > $odds_ratio_neg)
    {
	$adjnew{$adj} += 1;
    }
    
    if($odds_ratio_pos < $odds_ratio_neg)
    {
	$adjnew{$adj} -= 1;
    }

    if($odds_ratio_pos == $odds_ratio_neg)
    {
	$adjnew{$adj} += 0;
    }

}


sub mrd                                                                  # subroutine that calculates score of an adjective on basis of information obtained from MRD's
{
    $adj = $_[0];

    foreach $goodword(keys %good_words)
    {
	if($goodword eq $adj)                                            # check whether adjective occurs in good words hash 
	{
	    $adjnew{$adj} += 1;
	}
    }
	
    foreach $badword(keys %bad_words)
    {
	if($badword eq $adj)                                             # check whether adjective occurs in bad words hash
	{
	    $adjnew{$adj} -= 1;
	}
    }
    
    
}

